# encoding: UTF-8
require 'spec_helper'

describe Suppliers::TablesController, type: :controller do
  before :each do
    @supplier = Supplier.find_by_email('supplier@mozo.bar') || create(:supplier, :confirmed)
    #controller.stub(:table_params){ controller.params.require(:table).permit! } # allow all parameters since cross parameter injection is tested
    sign_in @supplier
  end

  describe "GET #index" do
    it "populates an array of tables" do
      table = create :table, supplier: @supplier
      get :index
      assigns(:tables).should eq([table])
    end

    it "does not include tables from another supplier" do
      table1 = create :table, supplier: @supplier
      table2 = create :table
      get :index
      assigns(:tables).should eq([table1])
    end

    it "should render without errors when no objects are present" do
      get :index
      expect{ render_template :index }.not_to raise_error
    end

    it "renders the :index view" do
      get :index
      response.should render_template :index
    end
  end

  describe "GET #show" do
    it "assigns the requested table to @table" do
      table = create :table, supplier: @supplier
      get :show, id: table
      assigns(:table).should eq(table)
    end

    it "should not display a table of another supplier" do
      table = create :table
      get :show, id: table
      response.status.should == 404
    end

    it "renders the #show view" do
      table = create :table, supplier: @supplier
      get :show, id: table
      response.should render_template :show
    end
  end

  describe "GET #new" do
    it "assigns a new table to @table" do
      get :new
      assigns(:table).should be_a Table
    end

    it "renders the #show view" do
      get :new
      response.should render_template :new
    end
  end

  describe "POST #create" do
    context "with valid attributes" do
      it "creates a new table" do
        expect{
          post :create, table: {number: 22}
        }.to change(Table, :count).by(1)
      end

      it "redirects to the new table" do
        post :create, table: {number: 22}
        response.should redirect_to [:suppliers, Table.last]
      end

      it "should not be possible to create a table for another supplier" do
        supplier2 = create :supplier
        expect { post :create, table: {number: 6, supplier_id: supplier2.id} }.to raise_error
        Table.find_by_number(6).should_not be_present
      end
    end

    context "with invalid attributes" do
      it "does not save the new table" do
        expect{
          post :create, table: {number: '-6'}
        }.to_not change(Table, :count)
      end

      it "re-renders the new method" do
        post :create, table: {number: '-6'}
        response.should render_template :new
      end
    end
  end

  describe 'PUT update' do
    before :each do
      @table = create :table, supplier: @supplier
    end

    context "valid attributes" do
      it "located the requested table" do
        put :update, id: @table, table: {number: 22}
        @table.reload
        assigns(:table).should eq(@table)
      end

      it "changes @table's number attribute" do
        put :update, id: @table, table: {number: "14"}
        @table.reload
        @table.number.should eq(14)
      end

      it "redirects to the updated table" do
        put :update, id: @table, table: {number: 22}
        response.should redirect_to [:suppliers, @table]
      end

      it "should not be possible to update a table to another supplier" do
        supplier2 = create :supplier
        expect{
          put :update, id: @table.id, table: {number: 6, supplier_id: supplier2.id}
        }.to raise_error
        @table.reload
        @table.supplier_id.should == @supplier.id
      end

      it "should not be possible to update a table of another supplier" do
        table = create :table, number: 11
        put :update, id: table, table: {number: 6}
        table.reload
        table.number.should == 11
      end
    end

    context "invalid attributes" do
      it "locates the requested table" do
        put :update, id: @table, table: {number: '-6'}
        assigns(:table).should eq(@table)
      end

      it "re-renders the edit method" do
        put :update, id: @table, table: {number: '-6'}
        response.should render_template :edit
      end
    end
  end

  describe 'DELETE destroy' do
    before :each do
      @table = create :table, supplier: @supplier
    end

    it "deletes the table" do
      expect{
        delete :destroy, id: @table        
      }.to change(Table, :count).by(-1)
    end

    it "redirects to tables#index" do
      delete :destroy, id: @table
      response.should redirect_to [:suppliers, :tables]
    end

    it "should not be possible to delete a table of another supplier" do
      table = create :table
      expect{
        delete :destroy, id: table
      }.to_not change(Table, :count)
    end
  end
end
